/*
	Ogg Vorbis CODEC for MSACM
	Copyright (C)2001 H.Mutsuki
*/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef __INC_VORBISACM_ENCODE__
#define __INC_VORBISACM_ENCODE__

#include "hmc/util.h"
#pragma warning(push,1)
#include "vorbis/codec.h"
#pragma warning(pop)
#include "vorbisacm.h"

/*****************************************************************
	Ogg Vorbis CODEC for MSACM
*****************************************************************/
/*****************************************************************
	Ogg Vorbis GR[h
*****************************************************************/
class COggVorbisEncode : public COggVorbisStreamInstance
{
public:
	DECLARE_SYNONYM(COggVorbisEncode,TYPE);
	DECLARE_SYNONYM(COggVorbisStreamInstance,BASE);
	operator LPTYPE() { return this; }
	friend DWORD oggFormatMakeupExtraByte(WAVEFORMATEX *pwfx);	// pII
public:
	COggVorbisEncode(CacmDriverOggVorbis *pDriver) : pDriver(pDriver) { init(); }
	~COggVorbisEncode() { destroy(); }
private:
	void init();
public:
	void destroy();
public:
	LRESULT Create(CONST WAVEFORMATEX *pwfxSrc, CONST WAVEFORMATEX *pwfxDst);
	LRESULT ConvertCallback(LPACMDRVSTREAMINSTANCE padsi, LPACMDRVSTREAMHEADER padsh);
private:
	DWORD ReadData (LPACMDRVSTREAMINSTANCE padsi, LPACMDRVSTREAMHEADER padsh);
	DWORD WritePage(LPACMDRVSTREAMINSTANCE padsi, LPACMDRVSTREAMHEADER padsh);
private:
	enum {
		READSIZE = 1024,
	};
	enum {
		STREAMSERIALNO_AUDIO    = 0,	// I[fBIXg[̃VAio[
		STREAMSERIALNO_PADDING  = -1,	// pfBOXg[̃VAio[
	};
	enum {
		ENCODE_FLAGS_PSEUDOCBR		= 0x00000080,
		ENCODE_FLAGS_RATEMANAGED	= 0x00000040,
		ENCODE_FLAGS_MODE1			= 0x00000001,
		ENCODE_FLAGS_MODE2			= 0x00000002,
		ENCODE_FLAGS_MODE3			= 0x00000004,
		ENCODE_FLAGS_HEADERPREPARED	= 0x80000000,
		ENCODE_FLAGS_EOS			= 0x08000000,
		ENCODE_FLAGS_EOF			= 0x04000000,
	};
private:
	// hCoCX^X
	CacmDriverOggVorbis *pDriver;
	// R[obNp
	DWORD dwFlags;				// etO
	DWORD cbSrcLengthUsed;		// PCM̓obt@σoCg
	DWORD cbDstLengthUsed;		// Bito̓obt@σoCg
	// rbg[gp
	float flCurBitrate;			// uԃrbg[g
	float flMaxBitrate;			// őrbg[g
	float flEstBitrate;			// ώZrbg[g
	DWORD cbSrcPrepared;		// ϓ̓oCg
	DWORD cbDstPrepared;		// Ϗo̓oCg
	DWORD cbPadPrepared;		// Pado̓oCg
	DWORD cbSrcLastPrepared;	// ϓ̓oCg
	DWORD cbDstLastPrepared;	// Ϗo̓oCg
	DWORD cbPadLastPrepared;	// Pado̓oCg
	// pfBOp
	ogg_stream_state os_pad;	// pfBOpXg[
	ogg_packet       op_pad;	// pfBOppPbg
	// OggVorbisXg[p
	ogg_stream_state os;		// take physical pages, weld into a logical stream of packets
	ogg_page         og;		// one Ogg bitstream page.  Vorbis packets are inside
	ogg_packet       op;		// one raw packet of data for decode
	vorbis_info      vi;		// struct that stores all the static vorbis bitstream settings
	vorbis_comment   vc;		// struct that stores all the user comments
	vorbis_dsp_state vd;		// central working state for the packet->PCM decoder
	vorbis_block     vb;		// local working space for packet->PCM decode
};

/*****************************************************************
*****************************************************************/

#endif	/* __INC_VORBISACM_ENCODE__ */

/* Local Variables:						*/
/* tab-width:4							*/
/* c-basic-offset:4						*/
/* c-indent-level:4						*/
/* c-label-offset:-4					*/
/* c-continued-statement-offset:4		*/
/* file-coding-system:*sjis*dos			*/
/* buffer-file-coding-system:sjis-dos	*/
/* End:									*/
